<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.C.ShaderInterface</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Int</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Void</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.C.String</span></span><span>
</span><span id="line-8"></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw.Types</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">SDL</span></span><span>
</span><span id="line-10"></span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html"><span class="hs-identifier">SDL.GPU.C.Types</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html"><span class="hs-identifier">SDL.GPU.C.Bool</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html"><span class="hs-identifier">SDL.GPU.C.NumericTypes</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-14"></span><span>
</span><span id="line-15"></span><span class="hs-comment">-- TODO: Did I newtype these Uint32s right? Are they all just shader program handles?</span><span>
</span><span id="line-16"></span><span>  </span><span>
</span><span id="line-17"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_CreateShaderProgram&quot;</span></span><span> </span><span id="createShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#createShaderProgram"><span class="hs-identifier hs-var">createShaderProgram</span></a></span></span><span>
</span><span id="line-18"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-19"></span><span>
</span><span id="line-20"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_FreeShaderProgram&quot;</span></span><span> </span><span id="freeShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#freeShaderProgram"><span class="hs-identifier hs-var">freeShaderProgram</span></a></span></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-23"></span><span>
</span><span id="line-24"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_CompileShader_RW&quot;</span></span><span> </span><span id="compileShaderRW"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#compileShaderRW"><span class="hs-identifier hs-var">compileShaderRW</span></a></span></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderEnum"><span class="hs-identifier hs-type">GPU.ShaderEnum</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.RWops</span></span><span> </span><span class="hs-comment">-- ^ shader_source</span><span>
</span><span id="line-27"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span> </span><span class="hs-comment">-- ^ free_rwops</span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-29"></span><span>
</span><span id="line-30"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_CompileShader&quot;</span></span><span> </span><span id="compileShader"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#compileShader"><span class="hs-identifier hs-var">compileShader</span></a></span></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderEnum"><span class="hs-identifier hs-type">GPU.ShaderEnum</span></a></span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ shader_source</span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-34"></span><span>
</span><span id="line-35"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_LoadShader&quot;</span></span><span> </span><span id="loadShader"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#loadShader"><span class="hs-identifier hs-var">loadShader</span></a></span></span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderEnum"><span class="hs-identifier hs-type">GPU.ShaderEnum</span></a></span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ filename</span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-39"></span><span>
</span><span id="line-40"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_LinkShaders&quot;</span></span><span> </span><span id="linkShaders"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#linkShaders"><span class="hs-identifier hs-var">linkShaders</span></a></span></span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span> </span><span class="hs-comment">-- ^ shader_object1</span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span> </span><span class="hs-comment">-- ^ shader_object2</span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-44"></span><span>
</span><span id="line-45"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_LinkManyShaders&quot;</span></span><span> </span><span id="linkManyShaders"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#linkManyShaders"><span class="hs-identifier hs-var">linkManyShaders</span></a></span></span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span> </span><span class="hs-comment">-- ^ shader_objects</span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ count</span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-49"></span><span>
</span><span id="line-50"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_FreeShader&quot;</span></span><span> </span><span id="freeShader"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#freeShader"><span class="hs-identifier hs-var">freeShader</span></a></span></span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-53"></span><span>
</span><span id="line-54"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_AttachShader&quot;</span></span><span> </span><span id="attachShader"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#attachShader"><span class="hs-identifier hs-var">attachShader</span></a></span></span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-58"></span><span>
</span><span id="line-59"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_DetachShader&quot;</span></span><span> </span><span id="detachShader"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#detachShader"><span class="hs-identifier hs-var">detachShader</span></a></span></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Shader"><span class="hs-identifier hs-type">GPU.Shader</span></a></span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-63"></span><span>
</span><span id="line-64"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_LinkShaderProgram&quot;</span></span><span> </span><span id="linkShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#linkShaderProgram"><span class="hs-identifier hs-var">linkShaderProgram</span></a></span></span><span>
</span><span id="line-65"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span>
</span><span id="line-67"></span><span>
</span><span id="line-68"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetCurrentShaderProgram&quot;</span></span><span> </span><span id="getCurrentShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getCurrentShaderProgram"><span class="hs-identifier hs-var">getCurrentShaderProgram</span></a></span></span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-70"></span><span>
</span><span id="line-71"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_IsDefaultShaderProgram&quot;</span></span><span> </span><span id="isDefaultShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#isDefaultShaderProgram"><span class="hs-identifier hs-var">isDefaultShaderProgram</span></a></span></span><span>
</span><span id="line-72"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span>
</span><span id="line-74"></span><span>
</span><span id="line-75"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_ActivateShaderProgram&quot;</span></span><span> </span><span id="activateShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#activateShaderProgram"><span class="hs-identifier hs-var">activateShaderProgram</span></a></span></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderBlock"><span class="hs-identifier hs-type">GPU.ShaderBlock</span></a></span><span>
</span><span id="line-78"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_DeactivateShaderProgram&quot;</span></span><span> </span><span id="deactivateShaderProgram"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#deactivateShaderProgram"><span class="hs-identifier hs-var">deactivateShaderProgram</span></a></span></span><span>
</span><span id="line-81"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-82"></span><span>
</span><span id="line-83"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetShaderMessage&quot;</span></span><span> </span><span id="getShaderMessage"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getShaderMessage"><span class="hs-identifier hs-var">getShaderMessage</span></a></span></span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span>
</span><span id="line-85"></span><span>
</span><span id="line-86"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetAttributeLocation&quot;</span></span><span> </span><span id="getAttributeLocation"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getAttributeLocation"><span class="hs-identifier hs-var">getAttributeLocation</span></a></span></span><span>
</span><span id="line-87"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ attrib_name</span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span>
</span><span id="line-90"></span><span>
</span><span id="line-91"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_MakeAttributeFormat&quot;</span></span><span> </span><span id="makeAttributeFormat"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#makeAttributeFormat"><span class="hs-identifier hs-var">makeAttributeFormat</span></a></span></span><span>
</span><span id="line-92"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#AttributeFormat"><span class="hs-identifier hs-type">GPU.AttributeFormat</span></a></span><span> </span><span class="hs-comment">-- ^ out</span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elems_per_vertex</span><span>
</span><span id="line-94"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#TypeEnum"><span class="hs-identifier hs-type">GPU.TypeEnum</span></a></span><span> </span><span class="hs-comment">-- ^ type</span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span> </span><span class="hs-comment">-- ^ normalize</span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ stride_bytes</span><span>
</span><span id="line-97"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ offset_bytes</span><span>
</span><span id="line-98"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-99"></span><span>
</span><span id="line-100"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_MakeAttribute&quot;</span></span><span> </span><span id="makeAttribute"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#makeAttribute"><span class="hs-identifier hs-var">makeAttribute</span></a></span></span><span>
</span><span id="line-101"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Attribute"><span class="hs-identifier hs-type">GPU.Attribute</span></a></span><span> </span><span class="hs-comment">-- ^ out</span><span>
</span><span id="line-102"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-103"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Void</span></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#AttributeFormat"><span class="hs-identifier hs-type">GPU.AttributeFormat</span></a></span><span>
</span><span id="line-105"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-106"></span><span>
</span><span id="line-107"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetUniformLocation&quot;</span></span><span> </span><span id="getUniformLocation"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getUniformLocation"><span class="hs-identifier hs-var">getUniformLocation</span></a></span></span><span>
</span><span id="line-108"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-109"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ uniform_name</span><span>
</span><span id="line-110"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span>
</span><span id="line-111"></span><span>
</span><span id="line-112"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_LoadShaderBlock&quot;</span></span><span> </span><span id="loadShaderBlock"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#loadShaderBlock"><span class="hs-identifier hs-var">loadShaderBlock</span></a></span></span><span>
</span><span id="line-113"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderBlock"><span class="hs-identifier hs-type">GPU.ShaderBlock</span></a></span><span> </span><span class="hs-comment">-- ^ out</span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ position_name</span><span>
</span><span id="line-116"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ texcoord_name</span><span>
</span><span id="line-117"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ color_name</span><span>
</span><span id="line-118"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">CString</span></span><span> </span><span class="hs-comment">-- ^ modelViewMatrix_name</span><span>
</span><span id="line-119"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-120"></span><span>
</span><span id="line-121"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_SetShaderBlock&quot;</span></span><span> </span><span id="setShaderBlock"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setShaderBlock"><span class="hs-identifier hs-var">setShaderBlock</span></a></span></span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderBlock"><span class="hs-identifier hs-type">GPU.ShaderBlock</span></a></span><span>
</span><span id="line-123"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-124"></span><span>
</span><span id="line-125"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_GetShaderBlock&quot;</span></span><span> </span><span id="getShaderBlock"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getShaderBlock"><span class="hs-identifier hs-var">getShaderBlock</span></a></span></span><span>
</span><span id="line-126"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderBlock"><span class="hs-identifier hs-type">GPU.ShaderBlock</span></a></span><span> </span><span class="hs-comment">-- ^ out</span><span>
</span><span id="line-127"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-128"></span><span>
</span><span id="line-129"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetShaderImage&quot;</span></span><span> </span><span id="setShaderImage"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setShaderImage"><span class="hs-identifier hs-var">setShaderImage</span></a></span></span><span>
</span><span id="line-130"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-131"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-132"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ image_unit</span><span>
</span><span id="line-133"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-134"></span><span>
</span><span id="line-135"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetUniformiv&quot;</span></span><span> </span><span id="getUniformiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getUniformiv"><span class="hs-identifier hs-var">getUniformiv</span></a></span></span><span>
</span><span id="line-136"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-137"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-138"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-139"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-140"></span><span>
</span><span id="line-141"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformi&quot;</span></span><span> </span><span id="setUniformi"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformi"><span class="hs-identifier hs-var">setUniformi</span></a></span></span><span>
</span><span id="line-142"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-143"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-144"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-145"></span><span>
</span><span id="line-146"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformiv&quot;</span></span><span> </span><span id="setUniformiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformiv"><span class="hs-identifier hs-var">setUniformiv</span></a></span></span><span>
</span><span id="line-147"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-148"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements_per_value</span><span>
</span><span id="line-149"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_values</span><span>
</span><span id="line-150"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-151"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-152"></span><span>
</span><span id="line-153"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetUniformuiv&quot;</span></span><span> </span><span id="getUniformuiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getUniformuiv"><span class="hs-identifier hs-var">getUniformuiv</span></a></span></span><span>
</span><span id="line-154"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-155"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-156"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#UnsignedInt"><span class="hs-identifier hs-type">GPU.UnsignedInt</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-157"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-158"></span><span>
</span><span id="line-159"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformui&quot;</span></span><span> </span><span id="setUniformui"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformui"><span class="hs-identifier hs-var">setUniformui</span></a></span></span><span>
</span><span id="line-160"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-161"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#UnsignedInt"><span class="hs-identifier hs-type">GPU.UnsignedInt</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-162"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-163"></span><span>
</span><span id="line-164"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformuiv&quot;</span></span><span> </span><span id="setUniformuiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformuiv"><span class="hs-identifier hs-var">setUniformuiv</span></a></span></span><span>
</span><span id="line-165"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-166"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements_per_value</span><span>
</span><span id="line-167"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_values</span><span>
</span><span id="line-168"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#UnsignedInt"><span class="hs-identifier hs-type">GPU.UnsignedInt</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-169"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-170"></span><span>
</span><span id="line-171"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetUniformfv&quot;</span></span><span> </span><span id="getUniformfv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getUniformfv"><span class="hs-identifier hs-var">getUniformfv</span></a></span></span><span>
</span><span id="line-172"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-173"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-174"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-175"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-176"></span><span>
</span><span id="line-177"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformf&quot;</span></span><span> </span><span id="setUniformf"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformf"><span class="hs-identifier hs-var">setUniformf</span></a></span></span><span>
</span><span id="line-178"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-179"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-180"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-181"></span><span>
</span><span id="line-182"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformfv&quot;</span></span><span> </span><span id="setUniformfv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformfv"><span class="hs-identifier hs-var">setUniformfv</span></a></span></span><span>
</span><span id="line-183"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-184"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements_per_value</span><span>
</span><span id="line-185"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_values</span><span>
</span><span id="line-186"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-187"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-188"></span><span>
</span><span id="line-189"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_GetUniformMatrixfv&quot;</span></span><span> </span><span id="getUniformMatrixfv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#getUniformMatrixfv"><span class="hs-identifier hs-var">getUniformMatrixfv</span></a></span></span><span>
</span><span id="line-190"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#ShaderProgram"><span class="hs-identifier hs-type">GPU.ShaderProgram</span></a></span><span>
</span><span id="line-191"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-192"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-193"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-194"></span><span>
</span><span id="line-195"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetUniformMatrixfv&quot;</span></span><span> </span><span id="setUniformMatrixfv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setUniformMatrixfv"><span class="hs-identifier hs-var">setUniformMatrixfv</span></a></span></span><span>
</span><span id="line-196"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-197"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_matrices</span><span>
</span><span id="line-198"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_rows</span><span>
</span><span id="line-199"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_columns</span><span>
</span><span id="line-200"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span>    </span><span class="hs-comment">-- ^ transpose</span><span>
</span><span id="line-201"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ values</span><span>
</span><span id="line-202"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-203"></span><span>
</span><span id="line-204"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributef&quot;</span></span><span> </span><span id="setAttributef"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributef"><span class="hs-identifier hs-var">setAttributef</span></a></span></span><span>
</span><span id="line-205"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-206"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-207"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-208"></span><span>
</span><span id="line-209"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributei&quot;</span></span><span> </span><span id="setAttributei"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributei"><span class="hs-identifier hs-var">setAttributei</span></a></span></span><span>
</span><span id="line-210"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-211"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-212"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-213"></span><span>
</span><span id="line-214"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributeui&quot;</span></span><span> </span><span id="setAttributeui"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributeui"><span class="hs-identifier hs-var">setAttributeui</span></a></span></span><span>
</span><span id="line-215"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-216"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#UnsignedInt"><span class="hs-identifier hs-type">GPU.UnsignedInt</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-217"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-218"></span><span>
</span><span id="line-219"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributefv&quot;</span></span><span> </span><span id="setAttributefv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributefv"><span class="hs-identifier hs-var">setAttributefv</span></a></span></span><span>
</span><span id="line-220"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-221"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements</span><span>
</span><span id="line-222"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-223"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-224"></span><span>
</span><span id="line-225"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributeiv&quot;</span></span><span> </span><span id="setAttributeiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributeiv"><span class="hs-identifier hs-var">setAttributeiv</span></a></span></span><span>
</span><span id="line-226"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-227"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements</span><span>
</span><span id="line-228"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-229"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-230"></span><span>
</span><span id="line-231"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_SetAttributeuiv&quot;</span></span><span> </span><span id="setAttributeuiv"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributeuiv"><span class="hs-identifier hs-var">setAttributeuiv</span></a></span></span><span>
</span><span id="line-232"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ location</span><span>
</span><span id="line-233"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_elements</span><span>
</span><span id="line-234"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#UnsignedInt"><span class="hs-identifier hs-type">GPU.UnsignedInt</span></a></span><span> </span><span class="hs-comment">-- ^ value</span><span>
</span><span id="line-235"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-236"></span><span>
</span><span id="line-237"></span><span class="hs-keyword">foreign</span><span> </span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-keyword">ccall</span></span><span> </span><span class="annot"><span class="hs-keyword">safe</span></span><span> </span><span class="annot"><span class="hs-string">&quot;SDL_gpu.h GPU_Adapter_SetAttributeSource&quot;</span></span><span> </span><span id="setAttributeSource"><span class="annot"><a href="SDL.GPU.C.ShaderInterface.html#setAttributeSource"><span class="hs-identifier hs-var">setAttributeSource</span></a></span></span><span>
</span><span id="line-238"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span> </span><span class="hs-comment">-- ^ num_values</span><span>
</span><span id="line-239"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Attribute"><span class="hs-identifier hs-type">GPU.Attribute</span></a></span><span> </span><span class="hs-comment">-- ^ source</span><span>
</span><span id="line-240"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-241"></span></pre></body></html>